## git 2.39.1

=== debian/changelog ===
git (1:2.39.1-1+WANdisco) unstable; urgency=low

  * WANdisco Release

 -- WANdisco <opensource@wandisco.com>  Mon, 13 Feb 2023 14:11:24 +0000
