## git 2.39.2

=== debian/changelog ===
git (1:2.39.2-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Sven Hoexter <hoexter@debian.org>  Thu, 23 Feb 2023 22:23:17 +0100

git (1:2.39.2-1) unstable; urgency=medium

  * new upstream point release (see RelNotes/2.39.2.txt).  Addresses
    CVE-2023-22490 and CVE-2023-23946.

 -- Jonathan Nieder <jrnieder@gmail.com>  Wed, 15 Feb 2023 17:08:12 -0800

git (1:2.39.1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream stable release (Closes: #1029114)
    Fixes CVE-2022-23521 and CVE-2022-41903.

 -- Aron Xu <aron@debian.org>  Thu, 26 Jan 2023 13:43:04 +0800
